Index: cards/CLICdet/CLICdet_JetScale_1500.tcl
===================================================================
--- cards/CLICdet/CLICdet_JetScale_1500.tcl	(revision d180044f298cd02433a4ddd2e0dddabeb66eb535)
+++ cards/CLICdet/CLICdet_JetScale_1500.tcl	(revision 6f96f629cc284e28bb02293d0d7fee8ae0b418e7)
@@ -4,149 +4,149 @@
 
      # Scale Formula
-    set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05)}
+    set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02)}
 }
 module EnergyScale JetEnergyScale_VLCR05N3 {                                       
  set InputArray  JetMomentumSmearing_VLCR05N3/JER_VLCjetsR05N3                                        
   set OutputArray JES_VLCjetsR05N3                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR05N4 {                                       
  set InputArray  JetMomentumSmearing_VLCR05N4/JER_VLCjetsR05N4                                        
   set OutputArray JES_VLCjetsR05N4                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR05N5 {                                       
  set InputArray  JetMomentumSmearing_VLCR05N5/JER_VLCjetsR05N5                                        
   set OutputArray JES_VLCjetsR05N5                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR05N6 {                                       
  set InputArray  JetMomentumSmearing_VLCR05N6/JER_VLCjetsR05N6                                        
   set OutputArray JES_VLCjetsR05N6                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR05_inclusive {                               
  set InputArray  JetMomentumSmearing_VLCR05_inclusive/JER_VLCjetsR05_inclusive                        
   set OutputArray JES_VLCjetsR05_inclusive                                                   
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR07N2 {                                       
  set InputArray  JetMomentumSmearing_VLCR07N2/JER_VLCjetsR07N2                                        
   set OutputArray JES_VLCjetsR07N2                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR07N3 {                                       
  set InputArray  JetMomentumSmearing_VLCR07N3/JER_VLCjetsR07N3                                        
   set OutputArray JES_VLCjetsR07N3                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR07N4 {                                       
  set InputArray  JetMomentumSmearing_VLCR07N4/JER_VLCjetsR07N4                                        
   set OutputArray JES_VLCjetsR07N4                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR07N5 {                                       
  set InputArray  JetMomentumSmearing_VLCR07N5/JER_VLCjetsR07N5                                        
   set OutputArray JES_VLCjetsR07N5                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR07N6 {                                       
  set InputArray  JetMomentumSmearing_VLCR07N6/JER_VLCjetsR07N6                                        
   set OutputArray JES_VLCjetsR07N6                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR07_inclusive {                               
  set InputArray  JetMomentumSmearing_VLCR07_inclusive/JER_VLCjetsR07_inclusive                        
   set OutputArray JES_VLCjetsR07_inclusive                                                   
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR10N2 {                                       
  set InputArray  JetMomentumSmearing_VLCR10N2/JER_VLCjetsR10N2                                        
   set OutputArray JES_VLCjetsR10N2                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR10N3 {                                       
  set InputArray  JetMomentumSmearing_VLCR10N3/JER_VLCjetsR10N3                                        
   set OutputArray JES_VLCjetsR10N3                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR10N4 {                                       
  set InputArray  JetMomentumSmearing_VLCR10N4/JER_VLCjetsR10N4                                        
   set OutputArray JES_VLCjetsR10N4                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR10N5 {                                       
  set InputArray  JetMomentumSmearing_VLCR10N5/JER_VLCjetsR10N5                                        
   set OutputArray JES_VLCjetsR10N5                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR10N6 {                                       
  set InputArray  JetMomentumSmearing_VLCR10N6/JER_VLCjetsR10N6                                        
   set OutputArray JES_VLCjetsR10N6                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR10_inclusive {                               
  set InputArray  JetMomentumSmearing_VLCR10_inclusive/JER_VLCjetsR10_inclusive                        
   set OutputArray JES_VLCjetsR10_inclusive                                                   
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR12N2 {                                       
  set InputArray  JetMomentumSmearing_VLCR12N2/JER_VLCjetsR12N2                                        
   set OutputArray JES_VLCjetsR12N2                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR12N3 {                                       
  set InputArray  JetMomentumSmearing_VLCR12N3/JER_VLCjetsR12N3                                        
   set OutputArray JES_VLCjetsR12N3                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR12N4 {                                       
  set InputArray  JetMomentumSmearing_VLCR12N4/JER_VLCjetsR12N4                                        
   set OutputArray JES_VLCjetsR12N4                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR12N5 {                                       
  set InputArray  JetMomentumSmearing_VLCR12N5/JER_VLCjetsR12N5                                        
   set OutputArray JES_VLCjetsR12N5                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR12N6 {                                       
  set InputArray  JetMomentumSmearing_VLCR12N6/JER_VLCjetsR12N6                                        
   set OutputArray JES_VLCjetsR12N6                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR12_inclusive {                               
  set InputArray  JetMomentumSmearing_VLCR12_inclusive/JER_VLCjetsR12_inclusive                        
   set OutputArray JES_VLCjetsR12_inclusive                                                   
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR15N2 {                                       
  set InputArray  JetMomentumSmearing_VLCR15N2/JER_VLCjetsR15N2                                        
   set OutputArray JES_VLCjetsR15N2                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR15N3 {                                       
  set InputArray  JetMomentumSmearing_VLCR15N3/JER_VLCjetsR15N3                                        
   set OutputArray JES_VLCjetsR15N3                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR15N4 {                                       
  set InputArray  JetMomentumSmearing_VLCR15N4/JER_VLCjetsR15N4                                        
   set OutputArray JES_VLCjetsR15N4                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR15N5 {                                       
  set InputArray  JetMomentumSmearing_VLCR15N5/JER_VLCjetsR15N5                                        
   set OutputArray JES_VLCjetsR15N5                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR15N6 {                                       
  set InputArray  JetMomentumSmearing_VLCR15N6/JER_VLCjetsR15N6                                        
   set OutputArray JES_VLCjetsR15N6                                                           
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                                                            
 module EnergyScale JetEnergyScale_VLCR15_inclusive {                               
  set InputArray  JetMomentumSmearing_VLCR15_inclusive/JER_VLCjetsR15_inclusive                        
   set OutputArray JES_VLCjetsR15_inclusive                                                   
-  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.05) }                                                              
+  set ScaleFormula { (abs(eta) < 0.76) * ( 1.0 ) + (abs(eta) >= 0.76 ) * (1.02) }                                                              
 }                                                 
Index: cards/delphes_card_CLICdet_Stage1.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage1.tcl	(revision d180044f298cd02433a4ddd2e0dddabeb66eb535)
+++ cards/delphes_card_CLICdet_Stage1.tcl	(revision 6f96f629cc284e28bb02293d0d7fee8ae0b418e7)
@@ -360,8 +360,8 @@
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) * 2 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
-      	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 2 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * 2 * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
-	(abs(eta) < 0.76 && abs(eta) >= 0.36 ) * sqrt( 1.16768e-05^2 * pt^2 +0.00255204^2    ) +
-	(abs(eta) < 0.36 && abs(eta) >= 0.18 ) * sqrt( 1.28327e-05^2 * pt^2 +0.00220587^2   ) +
+      	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.88 ) * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
+	(abs(eta) < 0.88 && abs(eta) >= 0.45 ) * sqrt( 1.16768e-05^2 * pt^2 +0.00255204^2    ) +
+	(abs(eta) < 0.45 && abs(eta) >= 0.18 ) * sqrt( 1.28327e-05^2 * pt^2 +0.00220587^2   ) +
 	(abs(eta) < 0.18)                      * sqrt( 1.32845e-05^2 * pt^2 +0.00209325^2   )
 	
@@ -381,8 +381,8 @@
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) * 2 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
-	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 2 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * 2 * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
-	(abs(eta) < 0.76 && abs(eta) >= 0.36 ) * sqrt( 1.15518e-05^2 * pt^2  + 0.00398644^2  ) +
-	(abs(eta) < 0.36 && abs(eta) >= 0.18 ) * sqrt( 1.3307e-05 ^2 * pt^2  + 0.00317807^2  ) +
+	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.88 ) * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
+	(abs(eta) < 0.88 && abs(eta) >= 0.45 ) * sqrt( 1.15518e-05^2 * pt^2  + 0.00398644^2  ) +
+	(abs(eta) < 0.45 && abs(eta) >= 0.18 ) * sqrt( 1.3307e-05 ^2 * pt^2  + 0.00317807^2  ) +
 	(abs(eta) < 0.18)                      * sqrt( 1.40722e-05^2 * pt^2  + 0.00292138^2  )
 
@@ -404,8 +404,8 @@
 
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) 	 * 2 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2 ) +
-	(abs(eta) < 1.74 && abs(eta) >= 1.32 )   * 2 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2 ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 )	 * 2 * sqrt(9.81626e-06^2 * pt^2   + 0.00379895^2  ) +
-	(abs(eta) < 0.76 && abs(eta) >= 0.36 )	 * sqrt(1.1959e-05^2 * pt^2   +  0.00242417^2 ) +
-	(abs(eta) < 0.36 && abs(eta) >= 0.18 )	 * sqrt(1.20149e-05^2 * pt^2  + 0.00219291^2  ) +
+	(abs(eta) < 1.74 && abs(eta) >= 1.32 )   * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2 ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.88 )	 * sqrt(9.81626e-06^2 * pt^2   + 0.00379895^2  ) +
+	(abs(eta) < 0.88 && abs(eta) >= 0.45 )	 * sqrt(1.1959e-05^2 * pt^2   +  0.00242417^2 ) +
+	(abs(eta) < 0.45 && abs(eta) >= 0.18 )	 * sqrt(1.20149e-05^2 * pt^2  + 0.00219291^2  ) +
 	(abs(eta) < 0.18)                     	 * sqrt(1.29686e-05^2 * pt^2  + 0.0020392^2      ) 
 
@@ -957,17 +957,4 @@
 
 
-###################
-## Jet Energy Scale
-###################
-#
-#module EnergyScale JetEnergyScale {
-#    set InputArray FastJetFinderVLC_R10_N4/VLCjetsR10N4
-#    set OutputArray jets
-#
-#    # scale formula for jets
-#    set ScaleFormula {1.00}
-#}
-
-
 ########################
 # Jet Flavor Association
Index: cards/delphes_card_CLICdet_Stage2.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage2.tcl	(revision d180044f298cd02433a4ddd2e0dddabeb66eb535)
+++ cards/delphes_card_CLICdet_Stage2.tcl	(revision 6f96f629cc284e28bb02293d0d7fee8ae0b418e7)
@@ -423,6 +423,6 @@
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) * 2 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
-      	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 2 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * 2 * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
+      	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 1.5 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
 	(abs(eta) < 0.76 && abs(eta) >= 0.36 ) * sqrt( 1.16768e-05^2 * pt^2 +0.00255204^2    ) +
 	(abs(eta) < 0.36 && abs(eta) >= 0.18 ) * sqrt( 1.28327e-05^2 * pt^2 +0.00220587^2   ) +
@@ -444,6 +444,6 @@
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) * 2 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
-	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 2 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * 2 * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
+	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 1.5 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
 	(abs(eta) < 0.76 && abs(eta) >= 0.36 ) * sqrt( 1.15518e-05^2 * pt^2  + 0.00398644^2  ) +
 	(abs(eta) < 0.36 && abs(eta) >= 0.18 ) * sqrt( 1.3307e-05 ^2 * pt^2  + 0.00317807^2  ) +
@@ -467,6 +467,6 @@
 
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) 	 * 2 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2	   ) +
-	(abs(eta) < 1.74 && abs(eta) >= 1.32 )   * 2 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2	   ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 )	 * 2 * sqrt(9.81626e-06^2 * pt^2   + 0.00379895^2  ) +
+	(abs(eta) < 1.74 && abs(eta) >= 1.32 )   * 1.5 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2	   ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.76 )	 * sqrt(9.81626e-06^2 * pt^2   + 0.00379895^2  ) +
 	(abs(eta) < 0.76 && abs(eta) >= 0.36 )	 * sqrt(1.1959e-05^2 * pt^2   +  0.00242417^2 ) +
 	(abs(eta) < 0.36 && abs(eta) >= 0.18 )	 * sqrt(1.20149e-05^2 * pt^2  + 0.00219291^2  ) +
Index: cards/delphes_card_CLICdet_Stage3.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage3.tcl	(revision d180044f298cd02433a4ddd2e0dddabeb66eb535)
+++ cards/delphes_card_CLICdet_Stage3.tcl	(revision 6f96f629cc284e28bb02293d0d7fee8ae0b418e7)
@@ -424,6 +424,6 @@
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) * 2 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
-      	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 2 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * 2 * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
+      	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 1.5 * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
 	(abs(eta) < 0.76 && abs(eta) >= 0.36 ) * sqrt( 1.16768e-05^2 * pt^2 +0.00255204^2    ) +
 	(abs(eta) < 0.36 && abs(eta) >= 0.18 ) * sqrt( 1.28327e-05^2 * pt^2 +0.00220587^2   ) +
@@ -445,6 +445,6 @@
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) * 2 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
-	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 2 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * 2 * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
+	(abs(eta) < 1.74 && abs(eta) >= 1.32 ) * 1.5 * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.76 ) * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
 	(abs(eta) < 0.76 && abs(eta) >= 0.36 ) * sqrt( 1.15518e-05^2 * pt^2  + 0.00398644^2  ) +
 	(abs(eta) < 0.36 && abs(eta) >= 0.18 ) * sqrt( 1.3307e-05 ^2 * pt^2  + 0.00317807^2  ) +
@@ -468,6 +468,6 @@
 
 	(abs(eta) < 2.66 && abs(eta) >= 1.74 ) 	 * 2 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2	   ) +
-	(abs(eta) < 1.74 && abs(eta) >= 1.32 )   * 2 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2	   ) +
-	(abs(eta) < 1.32 && abs(eta) >= 0.76 )	 * 2 * sqrt(9.81626e-06^2 * pt^2   + 0.00379895^2  ) +
+	(abs(eta) < 1.74 && abs(eta) >= 1.32 )   * 1.5 * sqrt(4.57439e-05^2 * pt^2   + 0.0149328^2	   ) +
+	(abs(eta) < 1.32 && abs(eta) >= 0.76 )	 * sqrt(9.81626e-06^2 * pt^2   + 0.00379895^2  ) +
 	(abs(eta) < 0.76 && abs(eta) >= 0.36 )	 * sqrt(1.1959e-05^2 * pt^2   +  0.00242417^2 ) +
 	(abs(eta) < 0.36 && abs(eta) >= 0.18 )	 * sqrt(1.20149e-05^2 * pt^2  + 0.00219291^2  ) +
@@ -1020,15 +1020,4 @@
 
 
-###################
-## Jet Energy Scale
-###################
-#
-#module EnergyScale JetEnergyScale {
-#    set InputArray FastJetFinderVLC_R10_N4/VLCjetsR10N4
-#    set OutputArray jets
-#
-#    # scale formula for jets
-#    set ScaleFormula {1.00}
-#}
 #########################################
 # Jet Momentum Smearing to mimick overlay