Index: cards/delphes_card_CLICdet_Stage1.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage1.tcl	(revision a0db751969c4238d2eb5a84c955e917b07eee124)
+++ cards/delphes_card_CLICdet_Stage1.tcl	(revision 8d7319c752fb023f34afdc897be781aef0e66dae)
@@ -298,10 +298,11 @@
 
     set EfficiencyFormula {
-	(abs(eta) > 2.54) * (0.000) +
-	(energy >= 80) * (abs(eta) < 2.54)  * (1.000) +
-	(energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
-	(energy < 80 && energy >= 3) * (abs(eta) <= 2.34) * (1.000) +
-	(energy < 3) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
-	(energy < 3) * (abs(eta) <= 0.55 ) * (1.000) 
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) < 2.54)                      * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)   * (0.994) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <= 2.34)                     * (1.000) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.990) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 0.55 )                    * (1.000) 
     }
 }
@@ -318,14 +319,14 @@
     # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
-	(pt <= 1)                                                               * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(energy >= 80)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
-	(energy >= 80)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
-	(energy >= 80)                 * (abs(eta) <= 2.34  )                   * (1.000) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
-	(energy < 5)   * (abs(eta) > 2.34 )                     * (0.000) +
-	(energy < 5)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
-	(energy < 5)   * (abs(eta) <= 0.76)                     * (0.999)
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.34  )                   * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.54 && abs(eta) > 2.34 ) * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 0.76)                     * (0.999)
     }
 }
@@ -341,14 +342,12 @@
     # Current full simulation with CLICdet provides for muons:
     set EfficiencyFormula {
-	(pt < 1)                                                                * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
-	(abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
-	(abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 && pt >=1 )        * (0.999) +
-	(abs(eta) <= 2.25 )                    * (energy >= 1)                  * (1.000) 
-
-	
+  (pt <= 0.1)                                                                          * (0.000) +
+  (pt > 0.1) * (abs(eta) > 2.54)                                                       * (0.000) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
+  (pt > 0.1) * (abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 )                  * (0.999) +
+  (pt > 0.1) * (abs(eta) <= 2.25 )                    * (energy < 5 )                  * (1.000) 
     }
 }
Index: cards/delphes_card_CLICdet_Stage2.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage2.tcl	(revision a0db751969c4238d2eb5a84c955e917b07eee124)
+++ cards/delphes_card_CLICdet_Stage2.tcl	(revision 8d7319c752fb023f34afdc897be781aef0e66dae)
@@ -490,10 +490,11 @@
 
     set EfficiencyFormula {
-	(abs(eta) > 2.54) * (0.000) +
-	(energy >= 80) * (abs(eta) < 2.54)  * (1.000) +
-	(energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
-	(energy < 80 && energy >= 3) * (abs(eta) <= 2.34) * (1.000) +
-	(energy < 3) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
-	(energy < 3) * (abs(eta) <= 0.55 ) * (1.000) 
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) < 2.54)                      * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)   * (0.994) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <= 2.34)                     * (1.000) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.990) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 0.55 )                    * (1.000) 
     }
 }
@@ -510,14 +511,14 @@
     # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
-	(pt <= 1)                                                               * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(energy >= 80)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
-	(energy >= 80)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
-	(energy >= 80)                 * (abs(eta) <= 2.34  )                   * (1.000) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
-	(energy < 5)   * (abs(eta) > 2.34 )                     * (0.000) +
-	(energy < 5)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
-	(energy < 5)   * (abs(eta) <= 0.76)                     * (0.999)
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.34  )                   * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.54 && abs(eta) > 2.34 ) * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 0.76)                     * (0.999)
     }
 }
@@ -533,14 +534,12 @@
     # Current full simulation with CLICdet provides for muons:
     set EfficiencyFormula {
-	(pt < 1)                                                                * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
-	(abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
-	(abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 && pt >=1 )        * (0.999) +
-	(abs(eta) <= 2.25 )                    * (energy >= 1)                  * (1.000) 
-
-	
+  (pt <= 0.1)                                                                          * (0.000) +
+  (pt > 0.1) * (abs(eta) > 2.54)                                                       * (0.000) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
+  (pt > 0.1) * (abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 )                  * (0.999) +
+  (pt > 0.1) * (abs(eta) <= 2.25 )                    * (energy < 5 )                  * (1.000) 
     }
 }
Index: cards/delphes_card_CLICdet_Stage3.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage3.tcl	(revision a0db751969c4238d2eb5a84c955e917b07eee124)
+++ cards/delphes_card_CLICdet_Stage3.tcl	(revision 8d7319c752fb023f34afdc897be781aef0e66dae)
@@ -484,10 +484,11 @@
 
     set EfficiencyFormula {
-	(abs(eta) > 2.54) * (0.000) +
-	(energy >= 80) * (abs(eta) < 2.54)  * (1.000) +
-	(energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
-	(energy < 80 && energy >= 3) * (abs(eta) <= 2.34) * (1.000) +
-	(energy < 3) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
-	(energy < 3) * (abs(eta) <= 0.55 ) * (1.000) 
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) < 2.54)                      * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)   * (0.994) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <= 2.34)                     * (1.000) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.990) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 0.55 )                    * (1.000) 
     }
 }
@@ -504,14 +505,14 @@
     # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
-	(pt <= 1)                                                               * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(energy >= 80)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
-	(energy >= 80)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
-	(energy >= 80)                 * (abs(eta) <= 2.34  )                   * (1.000) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
-	(energy < 5)   * (abs(eta) > 2.34 )                     * (0.000) +
-	(energy < 5)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
-	(energy < 5)   * (abs(eta) <= 0.76)                     * (0.999)
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.34  )                   * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.54 && abs(eta) > 2.34 ) * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 0.76)                     * (0.999)
     }
 }
@@ -527,14 +528,12 @@
     # Current full simulation with CLICdet provides for muons:
     set EfficiencyFormula {
-	(pt < 1)                                                                * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
-	(abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
-	(abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 && pt >=1 )        * (0.999) +
-	(abs(eta) <= 2.25 )                    * (energy >= 1)                  * (1.000) 
-
-	
+  (pt <= 0.1)                                                                          * (0.000) +
+  (pt > 0.1) * (abs(eta) > 2.54)                                                       * (0.000) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
+  (pt > 0.1) * (abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 )                  * (0.999) +
+  (pt > 0.1) * (abs(eta) <= 2.25 )                    * (energy < 5 )                  * (1.000) 
     }
 }
Index: cards/delphes_card_CLICdet_Stage3_fcal.tcl
===================================================================
--- cards/delphes_card_CLICdet_Stage3_fcal.tcl	(revision a0db751969c4238d2eb5a84c955e917b07eee124)
+++ cards/delphes_card_CLICdet_Stage3_fcal.tcl	(revision 8d7319c752fb023f34afdc897be781aef0e66dae)
@@ -492,10 +492,11 @@
 
     set EfficiencyFormula {
-	(abs(eta) > 2.54) * (0.000) +
-	(energy >= 80) * (abs(eta) < 2.54)  * (1.000) +
-	(energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
-	(energy < 80 && energy >= 3) * (abs(eta) <= 2.34) * (1.000) +
-	(energy < 3) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
-	(energy < 3) * (abs(eta) <= 0.55 ) * (1.000) 
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) < 2.54)                      * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <=2.54 && abs(eta) > 2.34)   * (0.994) +
+ (pt > 0.1) * (energy < 80 && energy >= 3) * (abs(eta) <= 2.34)                     * (1.000) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.990) +
+ (pt > 0.1) * (energy < 3)                 * (abs(eta) <= 0.55 )                    * (1.000) 
     }
 }
@@ -512,14 +513,14 @@
     # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
-	(pt <= 1)                                                               * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(energy >= 80)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
-	(energy >= 80)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
-	(energy >= 80)                 * (abs(eta) <= 2.34  )                   * (1.000) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
-	(energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
-	(energy < 5)   * (abs(eta) > 2.34 )                     * (0.000) +
-	(energy < 5)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
-	(energy < 5)   * (abs(eta) <= 0.76)                     * (0.999)
+ (pt <= 0.1)                                                                        * (0.000) +
+ (pt > 0.1)                                * (abs(eta) > 2.54)                      * (0.000) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
+ (pt > 0.1) * (energy >= 80)               * (abs(eta) <= 2.34  )                   * (1.000) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
+ (pt > 0.1) * (energy < 80 && energy >= 5) * (abs(eta) <= 2.17)                     * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.54 && abs(eta) > 2.34 ) * (1.000) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
+ (pt > 0.1) * (energy < 5)                 * (abs(eta) <= 0.76)                     * (0.999)
     }
 }
@@ -535,14 +536,12 @@
     # Current full simulation with CLICdet provides for muons:
     set EfficiencyFormula {
-	(pt < 1)                                                                * (0.000) +
-	(abs(eta) > 2.54)                                                       * (0.000) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
-	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
-	(abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
-	(abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 && pt >=1 )        * (0.999) +
-	(abs(eta) <= 2.25 )                    * (energy >= 1)                  * (1.000) 
-
-	
+  (pt <= 0.1)                                                                          * (0.000) +
+  (pt > 0.1) * (abs(eta) > 2.54)                                                       * (0.000) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 80)                 * (0.994) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 5 && energy < 80)   * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy < 5 )                  * (0.996) +
+  (pt > 0.1) * (abs(eta) <= 2.44 )                    * (energy >= 5 )                 * (1.000) +
+  (pt > 0.1) * (abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy < 5 )                  * (0.999) +
+  (pt > 0.1) * (abs(eta) <= 2.25 )                    * (energy < 5 )                  * (1.000) 
     }
 }